## pg-auto-failover 1.6.3

=== Makefile ===
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the PostgreSQL License.

TOP := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))

CONTAINER_NAME = pg_auto_failover
TEST_CONTAINER_NAME = pg_auto_failover_test
DOCKER_RUN_OPTS = --privileged  -ti --rm

NOSETESTS = $(shell which nosetests3 || which nosetests)

# Tests for the monitor
TESTS_MONITOR  = test_extension_update
TESTS_MONITOR += test_installcheck
TESTS_MONITOR += test_monitor_disabled
TESTS_MONITOR += test_replace_monitor

# This could be in TESTS_MULTI, but adding it here optimizes Travis run time
TESTS_MONITOR += test_multi_alternate_primary_failures

# Tests for single standby
TESTS_SINGLE  = test_auth
TESTS_SINGLE += test_basic_operation
TESTS_SINGLE += test_basic_operation_listen_flag
TESTS_SINGLE += test_create_run
TESTS_SINGLE += test_create_standby_with_pgdata
TESTS_SINGLE += test_ensure
TESTS_SINGLE += test_skip_pg_hba
TESTS_SINGLE += test_config_get_set

# Tests for SSL
TESTS_SSL  = test_enable_ssl
TESTS_SSL += test_ssl_cert
TESTS_SSL += test_ssl_self_signed

# This could be in TESTS_SINGLE, but adding it here optimizes Travis run time
TESTS_SSL += test_debian_clusters

# Tests for multiple standbys
TESTS_MULTI  = test_multi_async
TESTS_MULTI += test_multi_ifdown
TESTS_MULTI += test_multi_maintenance
TESTS_MULTI += test_multi_standbys

# TEST indicates the testfile to run
TEST ?=
ifeq ($(TEST),)
	TEST_ARGUMENT = --where=tests
else ifeq ($(TEST),multi)
	TEST_ARGUMENT = --where=tests --tests=$(TESTS_MULTI)
else ifeq ($(TEST),single)
	TEST_ARGUMENT = --where=tests --tests=$(TESTS_SINGLE)
else ifeq ($(TEST),monitor)
	TEST_ARGUMENT = --where=tests --tests=$(TESTS_MONITOR)
else ifeq ($(TEST),ssl)
	TEST_ARGUMENT = --where=tests --tests=$(TESTS_SSL)
else
	TEST_ARGUMENT = $(TEST:%=tests/%.py)
endif

# Documentation and images
FSM = docs/fsm.png
PDF = ./docs/_build/latex/pg_auto_failover.pdf

# Command line with DEBUG facilities
VALGRIND ?=
ifeq ($(VALGRIND),)
	BINPATH = ./src/bin/pg_autoctl/pg_autoctl
	PG_AUTOCTL = PG_AUTOCTL_DEBUG=1 ./src/bin/pg_autoctl/pg_autoctl
else
	BINPATH = $(abspath $(TOP))/src/tools/pg_autoctl.valgrind
	PG_AUTOCTL = PG_AUTOCTL_DEBUG=1 PG_AUTOCTL_DEBUG_BIN_PATH="$(BINPATH)" ./src/tools/pg_autoctl.valgrind
endif


NODES ?= 2						# total count of Postgres nodes
NODES_ASYNC ?= 0				# count of replication-quorum false nodes
NODES_PRIOS ?= 50				# either "50", or "50,50", or "50,50,0" etc
NODES_SYNC_SB ?= -1
FIRST_PGPORT ?= 5500
CLUSTER_OPTS = ""			# could be "--skip-pg-hba"

TMUX_EXTRA_COMMANDS ?= ""
TMUX_LAYOUT ?= even-vertical	# could be "tiled"
TMUX_TOP_DIR = ./tmux
TMUX_SCRIPT = ./tmux/script-$(FIRST_PGPORT).tmux

# make azcluster arguments
AZURE_PREFIX ?= ha-demo-$(shell whoami)
AZURE_REGION ?= paris
AZURE_LOCATION ?= francecentral

# Pick a version of Postgres and pg_auto_failover packages to install
# in our target Azure VMs when provisionning
#
#  sudo apt-get install -q -y postgresql-13-auto-failover-1.5=1.5.2
#  postgresql-${AZ_PG_VERSION}-auto-failover-${AZ_PGAF_DEB_VERSION}=${AZ_PGAF_VERSION}
AZ_PG_VERSION ?= 13
AZ_PGAF_DEB_VERSION ?= 1.6
AZ_PGAF_DEB_REVISION ?= 1.6.3-1

export AZ_PG_VERSION
export AZ_PGAF_DEB_VERSION
export AZ_PGAF_DEB_REVISION

all: monitor bin ;

install: install-monitor install-bin ;
clean: clean-monitor clean-bin ;
check: check-monitor ;

monitor:
	$(MAKE) -C src/monitor/ all

clean-monitor:
	$(MAKE) -C src/monitor/ clean

install-monitor: monitor
	$(MAKE) -C src/monitor/ install

check-monitor: install-monitor
	$(MAKE) -C src/monitor/ installcheck

bin:
	$(MAKE) -C src/bin/ all

clean-bin:
	$(MAKE) -C src/bin/ clean

install-bin: bin
	$(MAKE) -C src/bin/ install

test:
	sudo -E env "PATH=${PATH}" USER=$(shell whoami) \
		$(NOSETESTS)			\
		--verbose				\
		--nologcapture			\
		--nocapture				\
		--stop					\
		${TEST_ARGUMENT}

indent:
	citus_indent
	black .

docs: $(FSM)
	$(MAKE) -C docs html

build:
	docker build				    \
		$(DOCKER_BUILD_OPTS)		\
		-t $(CONTAINER_NAME)	    \
		.

interactive-test:
	docker run --name $(CONTAINER_NAME) --rm -ti $(CONTAINER_NAME)


build-test:
	docker build				    \
		$(DOCKER_BUILD_OPTS)		\
		--target build-test         \
		-t $(TEST_CONTAINER_NAME)	\
		.

run-test: build-test
	docker run					                \
		--name $(TEST_CONTAINER_NAME)		    \
		$(DOCKER_RUN_OPTS)			            \
		$(TEST_CONTAINER_NAME)			        \
		make -C /usr/src/pg_auto_failover test	\
		TEST='${TEST}'

build-i386:
	docker build -t i386:latest -f Dockerfile.i386 .

# expected to be run from within the i386 docker container
installcheck-i386:
	pg_autoctl run &
	pg_autoctl do pgsetup wait
	$(MAKE) -C src/monitor installcheck

run-installcheck-i386: build-i386
	docker run --platform linux/386 --rm -it --privileged i386 make installcheck-i386

man:
	$(MAKE) -C docs man

pdf: $(PDF)

$(PDF):
	$(MAKE) -s -C docs/tikz pdf
	perl -pi -e 's/(^.. figure:: .*)\.svg/\1.pdf/' docs/*.rst
	perl -pi -e 's/▒/~/g' docs/ref/pg_autoctl_do_demo.rst
	$(MAKE) -s -C docs latexpdf
	perl -pi -e 's/(^.. figure:: .*)\.pdf/\1.svg/' docs/*.rst
	perl -pi -e 's/~/▒/g' docs/ref/pg_autoctl_do_demo.rst
	ls -l $@

$(FSM): bin
	$(PG_AUTOCTL) do fsm gv | dot -Tpng > $@

$(TMUX_SCRIPT): bin
	mkdir -p $(TMUX_TOP_DIR)
	$(PG_AUTOCTL) do tmux script          \
         --root $(TMUX_TOP_DIR)           \
         --first-pgport $(FIRST_PGPORT)   \
         --nodes $(NODES)                 \
         --async-nodes $(NODES_ASYNC)     \
         --node-priorities $(NODES_PRIOS) \
         --sync-standbys $(NODES_SYNC_SB) \
         $(CLUSTER_OPTS)                  \
         --binpath $(BINPATH)             \
		 --layout $(TMUX_LAYOUT) > $@

tmux-script: $(TMUX_SCRIPT) ;

tmux-clean: bin
	$(PG_AUTOCTL) do tmux clean           \
         --root $(TMUX_TOP_DIR)           \
         --first-pgport $(FIRST_PGPORT)   \
         --nodes $(NODES)

tmux-session: bin
	$(PG_AUTOCTL) do tmux session         \
         --root $(TMUX_TOP_DIR)           \
         --first-pgport $(FIRST_PGPORT)   \
         --nodes $(NODES)                 \
         --async-nodes $(NODES_ASYNC)     \
         --node-priorities $(NODES_PRIOS) \
         --sync-standbys $(NODES_SYNC_SB) \
         $(CLUSTER_OPTS)                  \
         --binpath $(BINPATH)             \
         --layout $(TMUX_LAYOUT)

cluster: install tmux-clean
	# This is explicitly not a target, otherwise when make uses multiple jobs
	# tmux-clean and tmux-session can have a race condidition where tmux-clean
	# removes the files that are just created by tmux-session.
	$(MAKE) tmux-session

valgrind-session: build-test
	docker run                             \
	    --name $(TEST_CONTAINER_NAME) 	   \
		$(DOCKER_RUN_OPTS)			       \
		$(TEST_CONTAINER_NAME)			   \
	    make -C /usr/src/pg_auto_failover  \
	     VALGRIND=1 					   \
	     TMUX_TOP_DIR=/tmp/tmux 	       \
		 NODES=$(NODES) 				   \
		 NODES_ASYNC=$(NODES_ASYNC)        \
		 NODES_PRIOS=$(NODES_PRIOS)        \
		 NODES_SYNC_SB=$(NODES_SYNC_SB)    \
		 CLUSTER_OPTS=$(CLUSTER_OPTS)      \
		 TMUX_EXTRA_COMMANDS=$(TMUX_EXTRA_COMMANDS) \
		 TMUX_LAYOUT=$(TMUX_LAYOUT)        \
	     tmux-session

azcluster: all
	$(PG_AUTOCTL) do azure create         \
         --prefix $(AZURE_PREFIX)         \
         --region $(AZURE_REGION)         \
         --location $(AZURE_LOCATION)     \
         --nodes $(NODES)

# make azcluster has been done before, just re-attach
az: all
	$(PG_AUTOCTL) do azure tmux session

azdrop: all
	$(PG_AUTOCTL) do azure drop

.PHONY: all clean check install docs
.PHONY: monitor clean-monitor check-monitor install-monitor
.PHONY: bin clean-bin install-bin
.PHONY: build-test run-test
.PHONY: tmux-clean cluster
.PHONY: azcluster azdrop az

=== docs/requirements.txt ===
Sphinx==4.0.2
sphinx_rtd_theme_citus==0.5.16
docutils==0.16
readthedocs-sphinx-search==0.1.0

=== docs/tikz/Makefile ===
SRC = $(wildcard arch*.tex fsm.tex)
PDF = $(SRC:.tex=.pdf)
SVG = $(SRC:.tex=.svg)
PNG = $(SRC:.tex=.png)

all: pdf svg png ;

pdf: $(SRC) $(PDF) ;
svg: $(SRC) $(SVG) ;
png: $(SRC) $(PNG) ;

clean:
	latexmk -C
	rm -rf $(PDF)
	rm -rf $(SVG)
	rm -rf $(PNG)

%.pdf: %.tex common.tex
	latexmk -lualatex --interaction=nonstopmode -shell-escape $< $@
	latexmk -c

%.png: %.pdf
	pdftocairo -singlefile -r 300 -transp -png $<

%.svg: %.pdf
	pdftocairo -svg $<

.PHONY: clean

=== src/monitor/Makefile ===
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the PostgreSQL License.

EXTENSION = pgautofailover
EXTVERSION = 1.6

SRC_DIR := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))

DATA_built = $(EXTENSION)--$(EXTVERSION).sql
DATA = $(EXTENSION)--1.0.sql $(patsubst ${SRC_DIR}%,%,$(wildcard ${SRC_DIR}$(EXTENSION)--*--*.sql))

# compilation configuration
MODULE_big = $(EXTENSION)
OBJS = $(patsubst ${SRC_DIR}%.c,%.o,$(wildcard ${SRC_DIR}*.c))
PG_CPPFLAGS = -std=c99 -Wall -Werror -Wno-unused-parameter -Iinclude -I$(libpq_srcdir) -g
SHLIB_LINK = $(libpq)
REGRESS = create_extension monitor workers dummy_update drop_extension upgrade

PG_CONFIG ?= pg_config
PGXS = $(shell $(PG_CONFIG) --pgxs)
USE_PGXS = 1

.PHONY: cleanup-before-install

DEFAULT_CFLAGS = -std=c99 -D_GNU_SOURCE -g
DEFAULT_CFLAGS += $(shell $(PG_CONFIG) --cflags)
DEFAULT_CFLAGS += -Wformat
DEFAULT_CFLAGS += -Wall
DEFAULT_CFLAGS += -Werror=implicit-int
DEFAULT_CFLAGS += -Werror=implicit-function-declaration
DEFAULT_CFLAGS += -Werror=return-type
DEFAULT_CFLAGS += -Wno-declaration-after-statement

# Needed for OSX
DEFAULT_CFLAGS += -Wno-missing-braces

ifdef USE_SECURITY_FLAGS
# Flags taken from: https://liquid.microsoft.com/Web/Object/Read/ms.security/Requirements/Microsoft.Security.SystemsADM.10203#guide
SECURITY_CFLAGS=-fstack-protector-strong -D_FORTIFY_SOURCE=2 -O2 -z noexecstack -fpic -shared -Wl,-z,relro -Wl,-z,now -Wformat -Wformat-security -Werror=format-security
DEFAULT_CFLAGS += $(SECURITY_CFLAGS)
endif

override CFLAGS := $(DEFAULT_CFLAGS) $(CFLAGS)

include $(PGXS)

ifdef USE_SECURITY_FLAGS
# Flags taken from: https://liquid.microsoft.com/Web/Object/Read/ms.security/Requirements/Microsoft.Security.SystemsADM.10203#guide
SECURITY_BITCODE_CFLAGS=-fsanitize=safe-stack -fstack-protector-strong -flto -fPIC -Wformat -Wformat-security -Werror=format-security
override BITCODE_CFLAGS := $(BITCODE_CFLAGS) $(SECURITY_BITCODE_CFLAGS)
endif

cleanup-before-install:
	rm -f $(DESTDIR)$(datadir)/$(datamoduledir)/pgautofailover*

install: cleanup-before-install

$(EXTENSION)--$(EXTVERSION).sql: $(EXTENSION).sql
	cat $^ > $@

=== src/bin/pg_autoctl/Makefile ===
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the PostgreSQL License.

PG_AUTOCTL = ./pg_autoctl

SRC_DIR := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))

DEPDIR = $(SRC_DIR)/.deps

INCLUDES  = $(patsubst ${SRC_DIR}%.h,%.h,$(wildcard ${SRC_DIR}*.h))

SRC   = $(patsubst ${SRC_DIR}%.c,%.c,$(wildcard ${SRC_DIR}*.c))
OBJS  = $(patsubst %.c,%.o,$(SRC))
OBJS += lib-log.o lib-commandline.o lib-parson.o lib-snprintf.o lib-strerror.o

PG_CONFIG ?= pg_config
BINDIR    ?= $(shell $(PG_CONFIG) --bindir)

PG_SNPRINTF     = $(wildcard ${SRC_DIR}../lib/pg/snprintf.*)
LOG_SRC         = $(wildcard ${SRC_DIR}../lib/log/src/log.*)
COMMANDLINE_SRC = $(wildcard ${SRC_DIR}../lib/subcommands.c/commandline.*)
PARSON_SRC      = $(wildcard ${SRC_DIR}../lib/parson/parson.*)

COMMON_LIBS  = -I${SRC_DIR}../lib/pg
COMMON_LIBS += -I${SRC_DIR}../lib/log/src/
COMMON_LIBS += -I${SRC_DIR}../lib/subcommands.c/
COMMON_LIBS += -I${SRC_DIR}../lib/libs/
COMMON_LIBS += -I${SRC_DIR}../lib/parson/

CC = $(shell $(PG_CONFIG) --cc)

DEFAULT_CFLAGS = -std=c99 -D_GNU_SOURCE -g
DEFAULT_CFLAGS += -I $(shell $(PG_CONFIG) --includedir)
DEFAULT_CFLAGS += -I $(shell $(PG_CONFIG) --includedir-server)
DEFAULT_CFLAGS += -I $(shell $(PG_CONFIG) --pkgincludedir)/internal
DEFAULT_CFLAGS += $(shell $(PG_CONFIG) --cflags)
DEFAULT_CFLAGS += -Wformat
DEFAULT_CFLAGS += -Wall
DEFAULT_CFLAGS += -Werror=implicit-int
DEFAULT_CFLAGS += -Werror=implicit-function-declaration
DEFAULT_CFLAGS += -Werror=return-type
DEFAULT_CFLAGS += -Wno-declaration-after-statement

# Needed for OSX
DEFAULT_CFLAGS += -Wno-missing-braces
DEFAULT_CFLAGS += $(COMMON_LIBS)

ifdef USE_SECURITY_FLAGS
# Flags taken from: https://liquid.microsoft.com/Web/Object/Read/ms.security/Requirements/Microsoft.Security.SystemsADM.10203#guide
SECURITY_CFLAGS=-fstack-protector-strong -D_FORTIFY_SOURCE=2 -O2 -z noexecstack -fpie -Wl,-pie -Wl,-z,relro -Wl,-z,now -Wformat -Wformat-security -Werror=format-security
DEFAULT_CFLAGS += $(SECURITY_CFLAGS)
endif

override CFLAGS := $(DEFAULT_CFLAGS) $(CFLAGS)

LIBS  = -L $(shell $(PG_CONFIG) --pkglibdir)
LIBS += -L $(shell $(PG_CONFIG) --libdir)
LIBS += $(shell $(PG_CONFIG) --ldflags)
LIBS += $(shell $(PG_CONFIG) --libs)
LIBS += -lpq
LIBS += -lncurses

all: $(PG_AUTOCTL) ;

# Based on Postgres Makefile for automatic dependency generation
# https://github.com/postgres/postgres/blob/1933ae629e7b706c6c23673a381e778819db307d/src/Makefile.global.in#L890-L924
%.o : %.c
	@if test ! -d $(DEPDIR); then mkdir -p $(DEPDIR); fi
	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -o $@ $<

Po_files := $(wildcard $(DEPDIR)/*.Po)
ifneq (,$(Po_files))
include $(Po_files)
endif


$(PG_AUTOCTL): $(OBJS) $(INCLUDES)
	$(CC) $(CFLAGS) $(OBJS) $(LDFLAGS) $(LIBS) -o $@

lib-snprintf.o: $(PG_SNPRINTF)
	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/pg/snprintf.c

lib-strerror.o: $(PG_SNPRINTF)
	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/pg/strerror.c

lib-log.o: $(LOG_SRC)
	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/log/src/log.c

lib-commandline.o: $(COMMANDLINE_SRC)
	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/subcommands.c/commandline.c

lib-parson.o: $(PARSON_SRC)
	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/parson/parson.c

clean:
	rm -f $(OBJS) $(PG_AUTOCTL)
	rm -rf $(DEPDIR)

install: $(PG_AUTOCTL)
	install -d $(DESTDIR)$(BINDIR)
	install -m 0755 $(PG_AUTOCTL) $(DESTDIR)$(BINDIR)



.PHONY: all monitor clean

=== debian/changelog ===
pg-auto-failover (1.6.3-1) unstable; urgency=low

  * Official 1.6.3 release of pg_auto_failover

 -- Dimitri Fontaine <dim@tapoueh.org>  Tue, 09 Nov 2021 11:19:34 +0100

pg-auto-failover (1.6.2-1) stable; urgency=low

  * Official 1.6.2 release of pg_auto_failover

 -- Dimitri Fontaine <dim@tapoueh.org>  Thu, 09 Sep 2021 11:50:55 +0200

pg-auto-failover (1.6.1-1) stable; urgency=low

  * Official 1.6.1 release of pg_auto_failover

 -- Dimitri Fontaine <dim@tapoueh.org>  Thu, 08 Jul 2021 13:39:34 +0200

pg-auto-failover (1.5.2-1) stable; urgency=low

  * Official 1.5.2 release of pg_auto_failover

 -- Dimitri Fontaine <dim@tapoueh.org>  Fri, 21 May 2021 13:02:46 +0200

pg-auto-failover (1.5.1-1) stable; urgency=low

  * Official 1.5.1 release of pg_auto_failover

 -- Gurkan Indibay <gindibay@microsoft.com>  Thu, 25 Mar 2021 8:32:37 +0000

pg-auto-failover (1.4.2-1) stable; urgency=low

  * Official 1.4.2 release of pg_auto_failover

 -- Gurkan Indibay <gindibay@microsoft.com>  Thu, 4 Feb 2021 12:42:14 +0000

pg-auto-failover (1.4.1-1) stable; urgency=low

  * Official 1.4.1 release of pg_auto_failover

 -- Hanefi Onaldi <Hanefi.Onaldi@microsoft.com>  Thu, 3 Dec 2020 15:51:21 +0300

pg-auto-failover (1.4.0-1) stable; urgency=low

  * Official 1.4.0 release of pg_auto_failover

 -- Onur Tirtir <Onur.Tirtir@microsoft.com>  Wed, 23 Sep 2020 12:44:21 +0000

pg-auto-failover (1.3.1-1) stable; urgency=low

  * Official 1.3.1 release of pg_auto_failover

 -- Jelte Fennema <Jelte.Fennema@microsoft.com>  Thu, 7 May 2020 11:56:36 +0000

pg-auto-failover (1.2) testing; urgency=low

  * Official release of 1.2

 -- Murat Tuncer <murat.tuncer@microsoft.com>  Mon, 16 Mar 2020 20:00:00 +0200

pg-auto-failover (1.0.6) testing; urgency=low

  * Official release of 1.0.6

 -- Murat Tuncer <murat.tuncer@microsoft.com>  Thu, 13 Feb 2020 14:00:00 +0200

pg-auto-failover (1.0.5) testing; urgency=low
 
  * Official release of 1.0.5

 -- Murat Tuncer <murat.tuncer@microsoft.com>  Fri, 20 Sep 2019 14:00:00 +0200

pg-auto-failover (1.0.4) testing; urgency=low

  * Official release of 1.0.4

 -- Murat Tuncer <murat.tuncer@microsoft.com>  Thu, 5 Sep 2019 14:00:00 +0200

pg-auto-failover (1.0.3) testing; urgency=low

  * Official release of 1.0.3

 -- Murat Tuncer <murat.tuncer@microsoft.com>  Tue, 30 Jul 2019 14:00:00 +0200

pg-auto-failover (1.0.2) testing; urgency=low

  * Official release of 1.0.2

 -- Nils Dijk <nils@citusdata.com>  Thu, 23 May 2019 18:00:00 +0200

pg-auto-failover (1.0.1) testing; urgency=low

  * Official release of 1.0.1

 -- Nils Dijk <nils@citusdata.com>  Mon, 6 May 2019 16:00:00 +0200

pg-auto-failover (1.0.0) testing; urgency=low

  * First release of pg_auto_failover

 -- Nils Dijk <nils@citusdata.com>  Fri, 3 May 2019 16:00:00 +0200

=== debian/control ===
Source: pg-auto-failover
Section: database
Priority: optional
Maintainer: Dimitri Fontaine <dim@tapoueh.org>
Uploaders: Christoph Berg <myon@debian.org>
Build-Depends: debhelper (>= 12), flex, postgresql-server-dev-all (>= 158~), libedit-dev, libpam0g-dev, libreadline-dev, libselinux1-dev, libxslt1-dev, libssl-dev, libkrb5-dev, zlib1g-dev, python3-sphinx, liblz4-dev, libncurses-dev
Standards-Version: 4.5.1
Homepage: https://github.com/citusdata/pg_auto_failover

Package: pg-auto-failover-cli
Architecture: any
Depends: ${shlibs:Depends},${misc:Depends}, openssl
Recommends: postgresql-10-auto-failover | postgresql-11-auto-failover | postgresql-12-auto-failover | postgresql-13-auto-failover | postgresql-14-auto-failover
Description: Command line interface and service to manage pg auto failover Clusters
 This CLI is used to manage pg_auto_failover installations to provide High
 Availability to Postgres.

Package: postgresql-14-auto-failover
Architecture: any
Depends: ${shlibs:Depends},${misc:Depends}, postgresql-14, pg-auto-failover-cli (= ${binary:Version})
Description: Postgres high availability support
 This extension implements a set of functions to provide High Availability to
 Postgres.

=== debian/rules ===
#!/usr/bin/make -f

CLINAME := $(lastword $(shell grep "Package: pg-auto-failover-cli" debian/control))

include /usr/share/postgresql-common/pgxs_debian_control.mk
clean: debian/control

.PHONY: debian/control

override_dh_auto_build:
	+make -C $(shell pwd)/src/bin/pg_autoctl
	+pg_buildext build $(shell pwd)/src/monitor build-%v
	+make man

override_dh_auto_clean:
	+make -C $(shell pwd)/src/bin/pg_autoctl clean
	+pg_buildext clean $(shell pwd)/src/monitor build-%v

override_dh_auto_test:
	# nothing to do here, see debian/tests/* instead

override_dh_auto_install:
	+make -C $(shell pwd)/src/bin/pg_autoctl install \
		DESTDIR=$(CURDIR)/debian/${CLINAME} \
		BINDIR=/usr/bin
	+pg_buildext install $(shell pwd)/src/monitor build-%v postgresql-%v-auto-failover
	dh_installman docs/_build/man/*

%:
	dh $@

=== debian/tests/control ===
Depends: @, postgresql-contrib-14
Tests: installcheck
Restrictions: allow-stderr

## pg-auto-failover 1.6.4

=== Makefile ===
--- 
+++ 
@@ -4,9 +4,11 @@
 TOP := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))
 
 CONTAINER_NAME = pg_auto_failover
+BUILD_CONTAINER_NAME = pg_auto_failover_build
 TEST_CONTAINER_NAME = pg_auto_failover_test
 DOCKER_RUN_OPTS = --privileged  -ti --rm
 
+PGVERSION ?= 10
 NOSETESTS = $(shell which nosetests3 || which nosetests)
 
 # Tests for the monitor
@@ -97,7 +99,7 @@
 #  postgresql-${AZ_PG_VERSION}-auto-failover-${AZ_PGAF_DEB_VERSION}=${AZ_PGAF_VERSION}
 AZ_PG_VERSION ?= 13
 AZ_PGAF_DEB_VERSION ?= 1.6
-AZ_PGAF_DEB_REVISION ?= 1.6.3-1
+AZ_PGAF_DEB_REVISION ?= 1.6.4-1
 
 export AZ_PG_VERSION
 export AZ_PGAF_DEB_VERSION
@@ -130,7 +132,11 @@
 install-bin: bin
 	$(MAKE) -C src/bin/ install
 
+
 test:
+ifeq ($(TEST),tablespaces)
+	$(MAKE) -C tests/tablespaces run-test
+else
 	sudo -E env "PATH=${PATH}" USER=$(shell whoami) \
 		$(NOSETESTS)			\
 		--verbose				\
@@ -138,6 +144,7 @@
 		--nocapture				\
 		--stop					\
 		${TEST_ARGUMENT}
+endif
 
 indent:
 	citus_indent
@@ -146,30 +153,56 @@
 docs: $(FSM)
 	$(MAKE) -C docs html
 
-build:
-	docker build				    \
-		$(DOCKER_BUILD_OPTS)		\
-		-t $(CONTAINER_NAME)	    \
-		.
-
 interactive-test:
 	docker run --name $(CONTAINER_NAME) --rm -ti $(CONTAINER_NAME)
 
-
-build-test:
-	docker build				    \
-		$(DOCKER_BUILD_OPTS)		\
-		--target build-test         \
-		-t $(TEST_CONTAINER_NAME)	\
-		.
-
-run-test: build-test
+build-image:
+	docker build $(DOCKER_BUILD_OPTS) --target build -t $(BUILD_CONTAINER_NAME) .
+
+build-test-pg10: build-image
+	docker build --build-arg PGVERSION=10 --target test -t $(TEST_CONTAINER_NAME):pg10 .
+
+build-test-pg11:
+	docker build --build-arg PGVERSION=11 --target test -t $(TEST_CONTAINER_NAME):pg11 .
+
+build-test-pg12:
+	docker build --build-arg PGVERSION=12 --target test -t $(TEST_CONTAINER_NAME):pg12 .
+
+build-test-pg13:
+	docker build --build-arg PGVERSION=13 --target test -t $(TEST_CONTAINER_NAME):pg13 .
+
+build-test-pg14:
+	docker build --build-arg PGVERSION=14 --target test -t $(TEST_CONTAINER_NAME):pg14 .
+
+run-test: build-test-pg$(PGVERSION)
 	docker run					                \
 		--name $(TEST_CONTAINER_NAME)		    \
 		$(DOCKER_RUN_OPTS)			            \
-		$(TEST_CONTAINER_NAME)			        \
+		$(TEST_CONTAINER_NAME):pg$(PGVERSION)   \
 		make -C /usr/src/pg_auto_failover test	\
-		TEST='${TEST}'
+		PGVERSION=$(PGVERSION) TEST='${TEST}'
+
+build-pg10: build-test-pg10
+	docker build --build-arg PGVERSION=10 $(DOCKER_BUILD_OPTS) -t $(CONTAINER_NAME):pg10 .
+
+build-pg11: build-test-pg11
+	docker build --build-arg PGVERSION=11 $(DOCKER_BUILD_OPTS) -t $(CONTAINER_NAME):pg11 .
+
+build-pg12: build-test-pg12
+	docker build --build-arg PGVERSION=12 $(DOCKER_BUILD_OPTS) -t $(CONTAINER_NAME):pg12 .
+
+build-pg13: build-test-pg13
+	docker build --build-arg PGVERSION=13 $(DOCKER_BUILD_OPTS) -t $(CONTAINER_NAME):pg13 .
+
+build-pg14: build-test-pg14
+	docker build --build-arg PGVERSION=14 $(DOCKER_BUILD_OPTS) -t $(CONTAINER_NAME):pg14 .
+
+build: build-pg10 build-pg11 build-pg12 build-pg13 build-pg14 ;
+
+build-check:
+	for v in 10 11 12 13 14; do \
+		docker run --rm -t pg_auto_failover_test:pg$$v pg_autoctl version --json | jq ".pg_version" | xargs echo $$v: ; \
+	done
 
 build-i386:
 	docker build -t i386:latest -f Dockerfile.i386 .
@@ -233,11 +266,26 @@
          --binpath $(BINPATH)             \
          --layout $(TMUX_LAYOUT)
 
+tmux-compose-session:
+	$(PG_AUTOCTL) do tmux compose session \
+         --root $(TMUX_TOP_DIR)           \
+         --first-pgport $(FIRST_PGPORT)   \
+         --nodes $(NODES)                 \
+         --async-nodes $(NODES_ASYNC)     \
+         --node-priorities $(NODES_PRIOS) \
+         --sync-standbys $(NODES_SYNC_SB) \
+         $(CLUSTER_OPTS)                  \
+         --binpath $(BINPATH)             \
+         --layout $(TMUX_LAYOUT)
+
 cluster: install tmux-clean
 	# This is explicitly not a target, otherwise when make uses multiple jobs
 	# tmux-clean and tmux-session can have a race condidition where tmux-clean
 	# removes the files that are just created by tmux-session.
 	$(MAKE) tmux-session
+
+compose:
+	$(MAKE) tmux-compose-session
 
 valgrind-session: build-test
 	docker run                             \
@@ -274,5 +322,9 @@
 .PHONY: monitor clean-monitor check-monitor install-monitor
 .PHONY: bin clean-bin install-bin
 .PHONY: build-test run-test
-.PHONY: tmux-clean cluster
+.PHONY: tmux-clean cluster compose
 .PHONY: azcluster azdrop az
+.PHONY: build-image
+.PHONY: build-test-pg10 build-test-pg11 build-test-pg142
+.PHONY: build-test-pg13 build-test-pg14
+.PHONY: build build-pg10 build-pg11 build-pg12 build-pg13 build-pg14

=== tests/tablespaces/Makefile ===
PGVERSION ?= 10

build:
	$(MAKE) -C ../../ build-test-pg$(PGVERSION)
	docker-compose build --build-arg "PGVERSION=$(PGVERSION)"

teardown:
	docker-compose down --volumes --remove-orphans

tail:
	docker-compose logs -f

state:
	docker-compose exec monitor pg_autoctl show state

watch:
	docker-compose exec monitor pg_autoctl watch

test_01:
	docker-compose up -d node1
	TEST_NUM="01" docker-compose up --exit-code-from=test test

test_02:
	docker-compose up -d node2
	TEST_NUM="02" docker-compose up --exit-code-from=test test

test_03:
	# Pollute the data dir so pg_rewind fails
	docker-compose exec node2 mkdir '/var/lib/postgres/data/base/1/99999999'
	docker-compose exec monitor pg_autoctl perform failover
	TEST_NUM="03" docker-compose up --exit-code-from=test test

test_04:
	docker-compose pause node1
	TEST_NUM="04" docker-compose up --exit-code-from=test test

test_05:
	docker-compose unpause node1
	TEST_NUM="05" docker-compose up --exit-code-from=test test

test_06:
	docker-compose exec monitor pg_autoctl perform failover
	TEST_NUM="06" docker-compose up --exit-code-from=test test

test: build test_01 test_02 test_03 test_04 test_05 test_06

#  The test containers only connect to each other via the postgres protocol.
#    For this reason, the Makefile uses  `docker-compose exec` to perform
#    `pg_autoctl` commands, such as failover. Starting/stopping the pg_autoctl
#    process is also done using `docker-compose` so as not to complicate the
#    command used to run each container.
#  See CONTRIBUTING.md for more detailed instructions.
run-test: test teardown

.PHONY: build state watch run-test test tail teardown test_01 test_02 test_03 test_04 test_05 test_06

=== debian/changelog ===
pg-auto-failover (1.6.4-1.pgdg110+1) bullseye-pgdg; urgency=medium

  * Rebuild for bullseye-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Wed, 06 Apr 2022 15:21:56 +0200

pg-auto-failover (1.6.4-1) unstable; urgency=low

  * Official 1.6.4 release of pg_auto_failover

 -- Dimitri Fontaine <dim@tapoueh.org>  Wed, 06 Apr 2022 15:21:56 +0200

=== debian/control ===
--- 
+++ 
@@ -15,6 +15,34 @@
  This CLI is used to manage pg_auto_failover installations to provide High
  Availability to Postgres.
 
+Package: postgresql-10-auto-failover
+Architecture: any
+Depends: ${shlibs:Depends},${misc:Depends}, postgresql-10, pg-auto-failover-cli (= ${binary:Version})
+Description: Postgres high availability support
+ This extension implements a set of functions to provide High Availability to
+ Postgres.
+
+Package: postgresql-11-auto-failover
+Architecture: any
+Depends: ${shlibs:Depends},${misc:Depends}, postgresql-11, pg-auto-failover-cli (= ${binary:Version})
+Description: Postgres high availability support
+ This extension implements a set of functions to provide High Availability to
+ Postgres.
+
+Package: postgresql-12-auto-failover
+Architecture: any
+Depends: ${shlibs:Depends},${misc:Depends}, postgresql-12, pg-auto-failover-cli (= ${binary:Version})
+Description: Postgres high availability support
+ This extension implements a set of functions to provide High Availability to
+ Postgres.
+
+Package: postgresql-13-auto-failover
+Architecture: any
+Depends: ${shlibs:Depends},${misc:Depends}, postgresql-13, pg-auto-failover-cli (= ${binary:Version})
+Description: Postgres high availability support
+ This extension implements a set of functions to provide High Availability to
+ Postgres.
+
 Package: postgresql-14-auto-failover
 Architecture: any
 Depends: ${shlibs:Depends},${misc:Depends}, postgresql-14, pg-auto-failover-cli (= ${binary:Version})

=== debian/tests/control ===
Depends: @, postgresql-contrib-10, postgresql-contrib-11, postgresql-contrib-12, postgresql-contrib-13, postgresql-contrib-14
Tests: installcheck
Restrictions: allow-stderr

## pg-auto-failover 2.0

=== Makefile ===
--- 
+++ 
@@ -6,9 +6,10 @@
 CONTAINER_NAME = pg_auto_failover
 BUILD_CONTAINER_NAME = pg_auto_failover_build
 TEST_CONTAINER_NAME = pg_auto_failover_test
-DOCKER_RUN_OPTS = --privileged  -ti --rm
-
-PGVERSION ?= 10
+DOCKER_RUN_OPTS = --privileged --rm
+
+PGVERSION ?= 14
+
 NOSETESTS = $(shell which nosetests3 || which nosetests)
 
 # Tests for the monitor
@@ -44,10 +45,20 @@
 TESTS_MULTI += test_multi_maintenance
 TESTS_MULTI += test_multi_standbys
 
+# Tests for Citus
+TESTS_CITUS  = test_basic_citus_operation
+TESTS_CITUS += test_citus_cluster_name
+TESTS_CITUS += test_citus_force_failover
+TESTS_CITUS += test_citus_multi_standbys
+TESTS_CITUS += test_nonha_citus_operation
+TESTS_CITUS += test_citus_skip_pg_hba
+
 # TEST indicates the testfile to run
 TEST ?=
 ifeq ($(TEST),)
 	TEST_ARGUMENT = --where=tests
+else ifeq ($(TEST),citus)
+	TEST_ARGUMENT = --where=tests --tests=$(TESTS_CITUS)
 else ifeq ($(TEST),multi)
 	TEST_ARGUMENT = --where=tests --tests=$(TESTS_MULTI)
 else ifeq ($(TEST),single)
@@ -79,13 +90,25 @@
 NODES_ASYNC ?= 0				# count of replication-quorum false nodes
 NODES_PRIOS ?= 50				# either "50", or "50,50", or "50,50,0" etc
 NODES_SYNC_SB ?= -1
-FIRST_PGPORT ?= 5500
+
+CITUS = 0
+WORKERS = 2
+NODES_SECONDARY = 0
 CLUSTER_OPTS = ""			# could be "--skip-pg-hba"
 
 TMUX_EXTRA_COMMANDS ?= ""
 TMUX_LAYOUT ?= even-vertical	# could be "tiled"
 TMUX_TOP_DIR = ./tmux
 TMUX_SCRIPT = ./tmux/script-$(FIRST_PGPORT).tmux
+
+ifeq ($(CITUS),1)
+	FIRST_PGPORT ?= 5600
+	CLUSTER_OPTS += --citus
+	TMUX_TOP_DIR = ./tmux/citus
+else
+	FIRST_PGPORT ?= 5500
+	TMUX_TOP_DIR = ./tmux/pgsql
+endif
 
 # make azcluster arguments
 AZURE_PREFIX ?= ha-demo-$(shell whoami)
@@ -132,10 +155,31 @@
 install-bin: bin
 	$(MAKE) -C src/bin/ install
 
-
+#
+# make ci-test; is run on the GitHub Action workflow
+#
+# In that environment we have a local git checkout of the code, and docker
+# is available too. We run our tests in docker, except for the code linting
+# parts which requires full access to the git repository, so linter tooling
+# is installed directly on the CI vm.
+#
+ci-test:
+ifeq ($(TEST),tablespaces)
+	$(MAKE) -C tests/tablespaces run-test
+else ifeq ($(TEST),linting)
+	$(MAKE) spellcheck
+else
+	$(MAKE) run-test
+endif
+
+#
+# make test; is run from inside the testing Docker image.
+#
 test:
 ifeq ($(TEST),tablespaces)
 	$(MAKE) -C tests/tablespaces run-test
+else ifeq ($(TEST),linting)
+	$(MAKE) spellcheck
 else
 	sudo -E env "PATH=${PATH}" USER=$(shell whoami) \
 		$(NOSETESTS)			\
@@ -146,34 +190,69 @@
 		${TEST_ARGUMENT}
 endif
 
+#
+# make indent; edits the code when necessary
+#
 indent:
 	citus_indent
 	black .
 
-docs: $(FSM)
+#
+# make lint; is an alias for make spellcheck
+# make linting; is an alias for make spellcheck
+#
+lint: spellcheck ;
+linting: spellcheck ;
+
+#
+# make spellcheck; runs our linting tools without editing the code, only
+# reports compliance with the rules.
+#
+spellcheck:
+	citus_indent --check
+	black --check .
+	ci/banned.h.sh
+
+docs: $(FSM) tikz
 	$(MAKE) -C docs html
+
+tikz:
+	$(MAKE) -C docs/tikz all
 
 interactive-test:
 	docker run --name $(CONTAINER_NAME) --rm -ti $(CONTAINER_NAME)
 
 build-image:
-	docker build $(DOCKER_BUILD_OPTS) --target build -t $(BUILD_CONTAINER_NAME) .
-
-build-test-pg10: build-image
-	docker build --build-arg PGVERSION=10 --target test -t $(TEST_CONTAINER_NAME):pg10 .
+	docker build --target build -t $(BUILD_CONTAINER_NAME) .
+
+# Citus 9.0 seems to be the most recent version of Citus with Postgres 10
+# support, but fails to compile nowadays...
+# build-test-pg10:
+# 	docker build --build-arg PGVERSION=10 --build-arg CITUSTAG=v9.0.2 --target test -t $(TEST_CONTAINER_NAME):pg10 .
 
 build-test-pg11:
-	docker build --build-arg PGVERSION=11 --target test -t $(TEST_CONTAINER_NAME):pg11 .
+	docker build --build-arg PGVERSION=11 --build-arg CITUSTAG=v9.5.10 --target test -t $(TEST_CONTAINER_NAME):pg11 .
 
 build-test-pg12:
-	docker build --build-arg PGVERSION=12 --target test -t $(TEST_CONTAINER_NAME):pg12 .
+	docker build --build-arg PGVERSION=12 --build-arg CITUSTAG=v10.2.3 --target test -t $(TEST_CONTAINER_NAME):pg12 .
 
 build-test-pg13:
-	docker build --build-arg PGVERSION=13 --target test -t $(TEST_CONTAINER_NAME):pg13 .
+	docker build --build-arg PGVERSION=13 --build-arg CITUSTAG=v10.2.3 --target test -t $(TEST_CONTAINER_NAME):pg13 .
 
 build-test-pg14:
-	docker build --build-arg PGVERSION=14 --target test -t $(TEST_CONTAINER_NAME):pg14 .
-
+	docker build --build-arg PGVERSION=14 --build-arg CITUSTAG=v11.1.2 --target test -t $(TEST_CONTAINER_NAME):pg14 .
+
+build-test-pg15:
+	docker build --build-arg PGVERSION=15 --build-arg CITUSTAG=v11.1.2 --target test -t $(TEST_CONTAINER_NAME):pg15 .
+
+
+build-test-image: build-test-pg$(PGVERSION) ;
+
+
+#
+# make run-test; is the main testing entry point used to run tests inside
+# our testing Docker container. The docker container depends on PGVERSION.
+#
 run-test: build-test-pg$(PGVERSION)
 	docker run					                \
 		--name $(TEST_CONTAINER_NAME)		    \
@@ -182,30 +261,36 @@
 		make -C /usr/src/pg_auto_failover test	\
 		PGVERSION=$(PGVERSION) TEST='${TEST}'
 
-build-pg10: build-test-pg10
-	docker build --build-arg PGVERSION=10 $(DOCKER_BUILD_OPTS) -t $(CONTAINER_NAME):pg10 .
+# build-pg10: build-test-pg10
+# 	docker build --build-arg PGVERSION=10 -t $(CONTAINER_NAME):pg10 .
 
 build-pg11: build-test-pg11
-	docker build --build-arg PGVERSION=11 $(DOCKER_BUILD_OPTS) -t $(CONTAINER_NAME):pg11 .
+	docker build --build-arg PGVERSION=11 -t $(CONTAINER_NAME):pg11 .
 
 build-pg12: build-test-pg12
-	docker build --build-arg PGVERSION=12 $(DOCKER_BUILD_OPTS) -t $(CONTAINER_NAME):pg12 .
+	docker build --build-arg PGVERSION=12 -t $(CONTAINER_NAME):pg12 .
 
 build-pg13: build-test-pg13
-	docker build --build-arg PGVERSION=13 $(DOCKER_BUILD_OPTS) -t $(CONTAINER_NAME):pg13 .
+	docker build --build-arg PGVERSION=13 -t $(CONTAINER_NAME):pg13 .
 
 build-pg14: build-test-pg14
-	docker build --build-arg PGVERSION=14 $(DOCKER_BUILD_OPTS) -t $(CONTAINER_NAME):pg14 .
-
-build: build-pg10 build-pg11 build-pg12 build-pg13 build-pg14 ;
+	docker build --build-arg PGVERSION=14 -t $(CONTAINER_NAME):pg14 .
+
+build-pg15: build-test-pg15
+	docker build --build-arg PGVERSION=15 -t $(CONTAINER_NAME):pg15 .
+
+build: build-pg11 build-pg12 build-pg13 build-pg14 build-pg15 ;
 
 build-check:
-	for v in 10 11 12 13 14; do \
+	for v in 11 12 13 14 15; do \
 		docker run --rm -t pg_auto_failover_test:pg$$v pg_autoctl version --json | jq ".pg_version" | xargs echo $$v: ; \
 	done
 
 build-i386:
 	docker build -t i386:latest -f Dockerfile.i386 .
+
+build-demo:
+	docker build -t citusdata/pg_auto_failover:demo .
 
 # expected to be run from within the i386 docker container
 installcheck-i386:
@@ -219,7 +304,7 @@
 man:
 	$(MAKE) -C docs man
 
-pdf: $(PDF)
+pdf: $(PDF) ;
 
 $(PDF):
 	$(MAKE) -s -C docs/tikz pdf
@@ -242,6 +327,8 @@
          --async-nodes $(NODES_ASYNC)     \
          --node-priorities $(NODES_PRIOS) \
          --sync-standbys $(NODES_SYNC_SB) \
+         --citus-workers $(WORKERS) \
+         --citus-secondaries $(NODES_SECONDARY) \
          $(CLUSTER_OPTS)                  \
          --binpath $(BINPATH)             \
 		 --layout $(TMUX_LAYOUT) > $@
@@ -252,7 +339,10 @@
 	$(PG_AUTOCTL) do tmux clean           \
          --root $(TMUX_TOP_DIR)           \
          --first-pgport $(FIRST_PGPORT)   \
-         --nodes $(NODES)
+         --nodes $(NODES)                 \
+         --citus-workers $(WORKERS)       \
+         --citus-secondaries $(NODES_SECONDARY) \
+         $(CLUSTER_OPTS)
 
 tmux-session: bin
 	$(PG_AUTOCTL) do tmux session         \
@@ -262,6 +352,8 @@
          --async-nodes $(NODES_ASYNC)     \
          --node-priorities $(NODES_PRIOS) \
          --sync-standbys $(NODES_SYNC_SB) \
+         --citus-workers $(WORKERS)       \
+         --citus-secondaries $(NODES_SECONDARY) \
          $(CLUSTER_OPTS)                  \
          --binpath $(BINPATH)             \
          --layout $(TMUX_LAYOUT)
@@ -274,6 +366,8 @@
          --async-nodes $(NODES_ASYNC)     \
          --node-priorities $(NODES_PRIOS) \
          --sync-standbys $(NODES_SYNC_SB) \
+         --citus-workers $(WORKERS)       \
+         --citus-secondaries $(NODES_SECONDARY) \
          $(CLUSTER_OPTS)                  \
          --binpath $(BINPATH)             \
          --layout $(TMUX_LAYOUT)
@@ -290,8 +384,8 @@
 valgrind-session: build-test
 	docker run                             \
 	    --name $(TEST_CONTAINER_NAME) 	   \
-		$(DOCKER_RUN_OPTS)			       \
-		$(TEST_CONTAINER_NAME)			   \
+		$(DOCKER_RUN_OPTS) -it		       \
+		$(TEST_CONTAINER_NAME):pg14		   \
 	    make -C /usr/src/pg_auto_failover  \
 	     VALGRIND=1 					   \
 	     TMUX_TOP_DIR=/tmp/tmux 	       \
@@ -318,13 +412,4 @@
 azdrop: all
 	$(PG_AUTOCTL) do azure drop
 
-.PHONY: all clean check install docs
-.PHONY: monitor clean-monitor check-monitor install-monitor
-.PHONY: bin clean-bin install-bin
-.PHONY: build-test run-test
-.PHONY: tmux-clean cluster compose
-.PHONY: azcluster azdrop az
-.PHONY: build-image
-.PHONY: build-test-pg10 build-test-pg11 build-test-pg142
-.PHONY: build-test-pg13 build-test-pg14
-.PHONY: build build-pg10 build-pg11 build-pg12 build-pg13 build-pg14
+.PHONY: all clean check install docs tikz

=== docs/citus/Makefile ===
CONTAINER_NAME = pg_auto_failover:citus

all: build up;

build:
	docker build -t $(CONTAINER_NAME) -f Dockerfile ../..

up:
	docker-compose up --scale coord=2 --scale worker=6

down:
	docker-compose down

state:
	docker-compose exec monitor pg_autoctl show state

failover:
	docker-compose exec monitor pg_autoctl perform failover --group 1

nodes:
	docker-compose exec coord psql -d analytics -c 'table pg_dist_node'

=== docs/tutorial/Makefile ===
CONTAINER_NAME = pg_auto_failover:tutorial

all: build down up;

build:
	docker build -t $(CONTAINER_NAME) -f Dockerfile ../..
	docker-compose build

up:
	docker-compose up

down:
	docker-compose down --volumes --remove-orphans
	rm -rf {monitor,node1,node2,node3}/pgaf/

state:
	docker-compose exec monitor pg_autoctl show state

switchover:
	docker-compose exec monitor pg_autoctl perform switchover

=== src/monitor/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # Licensed under the PostgreSQL License.
 
 EXTENSION = pgautofailover
-EXTVERSION = 1.6
+EXTVERSION = 2.0
 
 SRC_DIR := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))

=== tests/upgrade/Makefile ===
NODES ?= 3

PATCH = tests/upgrade/monitor-upgrade-1.7.patch
Q_VERSION = select default_version, installed_version
Q_VERSION += from pg_available_extensions where name = 'pgautofailover'

build:
	docker-compose build

patch:
	cd ../.. && git apply $(PATCH)

clean:
	cd ../.. && git apply --reverse $(PATCH)

up: create-volumes compose-up tail ;

down: compose-down rm-volumes ;

compose-down:
	docker-compose down --volumes --remove-orphans

compose-up:
	docker-compose up -d

tail:
	docker-compose logs -f

create-volumes:
	for v in volm vol1 vol2 vol3; do docker volume create $$v; done

rm-volumes:
	for v in volm vol1 vol2 vol3; do docker volume rm $$v; done

upgrade-monitor: patch
	docker-compose up -d --no-deps --build monitor

upgrade-nodes:
	docker-compose up -d --no-deps --build node3 node2
	docker-compose up -d --no-deps --build node1

state:
	docker-compose exec monitor pg_autoctl show state

version:
	docker-compose exec monitor pg_autoctl version
	docker-compose exec monitor psql -d pg_auto_failover -c "$(Q_VERSION)"

failover:
	docker-compose exec monitor pg_autoctl perform failover

watch:
	docker-compose exec monitor watch -n 0.2 pg_autoctl show state

.PHONY: build patch clean up down upgrade-monitor state watch
.PHONY: compose-down compose-up create-volumes rm-volumes

=== debian/changelog ===
pg-auto-failover (2.0-2) unstable; urgency=medium

  * Upload for PostgreSQL 15.

 -- Christoph Berg <myon@debian.org>  Wed, 02 Nov 2022 17:12:43 +0100

pg-auto-failover (2.0-1) unstable; urgency=low

  * Official 2.0 release of pg_auto_failover
  * Add B-D on libzstd-dev.

 -- Dimitri Fontaine <dim@tapoueh.org>  Fri, 07 Oct 2022 12:38:25 +0200

=== debian/control ===
Source: pg-auto-failover
Section: database
Priority: optional
Maintainer: Dimitri Fontaine <dim@tapoueh.org>
Uploaders:
 Christoph Berg <myon@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 flex,
 libedit-dev,
 libkrb5-dev,
 liblz4-dev,
 libncurses-dev,
 libpam0g-dev,
 libreadline-dev,
 libselinux1-dev,
 libssl-dev,
 libxslt1-dev,
 libzstd-dev,
 postgresql-server-dev-all (>= 158~),
 python3-sphinx,
 zlib1g-dev,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://github.com/citusdata/pg_auto_failover

Package: pg-auto-failover-cli
Architecture: any
Depends:
 openssl,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 postgresql-10-auto-failover | postgresql-11-auto-failover | postgresql-12-auto-failover | postgresql-13-auto-failover | postgresql-14-auto-failover | postgresql-15-auto-failover,
Description: Command line interface and service to manage pg auto failover Clusters
 This CLI is used to manage pg_auto_failover installations to provide High
 Availability to Postgres.

Package: postgresql-15-auto-failover
Architecture: any
Depends:
 pg-auto-failover-cli (= ${binary:Version}),
 postgresql-15,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Postgres high availability support
 This extension implements a set of functions to provide High Availability to
 Postgres.

=== debian/tests/control ===
Depends: @, postgresql-contrib-15
Tests: installcheck
Restrictions: allow-stderr
